precision mediump float;

varying vec2 v_tex_coord;
uniform sampler2D s_texture;

uniform float u_coeff[3];
uniform vec2 u_offset;

void main(void)
{
  mediump vec3 A = u_coeff[0] * texture2D(s_texture, v_tex_coord - u_offset).xyz;
  mediump vec3 B = u_coeff[1] * texture2D(s_texture, v_tex_coord).xyz;
  mediump vec3 C = u_coeff[2] * texture2D(s_texture, v_tex_coord + u_offset).xyz;
  mediump vec3 color = A + B + C;

  gl_FragColor = vec4(color, 1); 
}
