precision mediump float;

#defint GAME_FILTER_KERNEL_SIZE_MAX 3

varying vec2 v_tex_coord;

uniform sampler2D s_texture;
uniform float u_kernel[GAME_FILTER_KERNEL_SIZE_MAX];
uniform int u_kernel_size;
uniform vec2 u_offset;
uniform vec4 u_color;
uniform float u_strength;

void main(void)
{
  float res_alpha = 0.0;
  vec2 offset = -u_offset;
  vec2 step = u_offset * 2.0 / float(u_kernel_size);
  for(int i = 0; i < GAME_FILTER_KERNEL_SIZE_MAX; ++i)
  {
    if(i < u_kernel_size)
    {
      res_alpha += u_kernel[i] * texture2D(s_texture, v_tex_coord + offset).a;
      offset += step;
    }
  }

  gl_FragColor = u_color * clamp(res_alpha * u_strength, 0.0, 1.0);
}
