precision highp float;

uniform float u_time;
uniform vec2 u_resolution;
uniform vec2 u_offset;
uniform sampler2D s_texture;
uniform float u_alpha;
varying vec2 v_tex_coord;

void main()
{          
  float max_rad = 0.3;
  vec2 cpos = -1.0 + 2.0 * (gl_FragCoord.xy + u_offset) / u_resolution.xy;
  float length = length(cpos);                
  vec4 res_color_orig = texture2D(s_texture, v_tex_coord);
  res_color_orig.a = u_alpha;
  gl_FragColor = res_color_orig;
  if(max_rad > length)
  {
    vec2 uv = v_tex_coord - (cpos/length)*sin((u_time / 0.3) * 3.14159265358)*0.03;
    vec4 res_color = texture2D(s_texture, clamp(uv, 0.01, 0.9));
    gl_FragColor = mix(res_color_orig, res_color, ((max_rad - length) / max_rad));
  }
}
