precision mediump float;

uniform highp mat4 u_mvp;
attribute highp vec4 a_position;

#ifdef TEXTURE
attribute highp vec2 a_tex_coord;
varying highp vec2 v_tex_coord;
#endif

#ifdef VERTEX_COLOR
attribute lowp vec4 a_color;
varying lowp vec4 v_color;
#endif

#ifdef MASK
attribute highp vec2 a_mask_tex_coord;
varying highp vec2 v_mask_tex_coord;
#endif

void main()
{
#ifdef TEXTURE
  v_tex_coord = a_tex_coord;
#endif

#ifdef VERTEX_COLOR
  v_color = a_color;
#endif

#ifdef MASK
  v_mask_tex_coord = a_mask_tex_coord;
#endif

  gl_Position = u_mvp * a_position;
}

